<?php
/*
Plugin Name: Simple SEO Slideshow
Plugin URI: http://www.hostdog.gr/
Description: Create Simple Slideshow from Post/Page Gallery (W3C Valid)
Author: Spyros Vlachopoulos
Version: 1.1.1
Author URI: http://www.hostdog.gr/
*/
 
 
class simpleSEOSlideshowWidget extends WP_Widget {
  function simpleSEOSlideshowWidget() {
    $widget_ops = array('classname' => 'simpleSlideshowWidget', 'description' => 'Displays a slideshow from post/page gallery' );
    $this->WP_Widget('simpleSlideshowWidget', 'Post/Page Slideshow', $widget_ops);
    
  }
 
  function form($instance) {
    $instance = wp_parse_args( (array) $instance, array( 'title' => '', 'pid' => ''  ) );
    $title = esc_attr($instance['title']);
    $pid = esc_attr($instance['pid']);
    $delay = esc_attr($instance['delay']);
    $ssheight = esc_attr($instance['ssheight']);
    $sssdisplaybul = esc_attr($instance['sssdisplaybul']);
    $sssdisplayarr = esc_attr($instance['sssdisplayarr']);
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>">Title: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p>
  <p><label for="<?php echo $this->get_field_id('pid'); ?>">Page/Post ID: <input class="widefat" id="<?php echo $this->get_field_id('pid'); ?>" name="<?php echo $this->get_field_name('pid'); ?>" type="text" value="<?php echo attribute_escape($pid); ?>" /></label></p>
  <p><label for="<?php echo $this->get_field_id('delay'); ?>">Delay in seconds: <input class="widefat" id="<?php echo $this->get_field_id('delay'); ?>" name="<?php echo $this->get_field_name('delay'); ?>" type="text" value="<?php echo attribute_escape($delay); ?>" /></label></p>
  <p><label for="<?php echo $this->get_field_id('ssheight'); ?>">Slideshow Height: <input class="widefat" id="<?php echo $this->get_field_id('ssheight'); ?>" name="<?php echo $this->get_field_name('ssheight'); ?>" type="text" value="<?php echo attribute_escape($ssheight); ?>" /></label></p>
  <p><label for="<?php echo $this->get_field_id('sssdisplaybul'); ?>">Display Bullets: 
        <select id="<?php echo $this->get_field_id('sssdisplaybul'); ?>" name="<?php echo $this->get_field_name('sssdisplaybul'); ?>" >
          <option value="yes" <?php if ($sssdisplaybul == 'yes') echo 'selected="selected"'; ?>>yes</option>
          <option value="no" <?php if ($sssdisplaybul == 'no') echo ' selected="selected"'; ?>>no</option>
        </select>
      </label>
  </p>
  <p><label for="<?php echo $this->get_field_id('sssdisplayarr'); ?>">Display Arrows: 
        <select id="<?php echo $this->get_field_id('sssdisplayarr'); ?>" name="<?php echo $this->get_field_name('sssdisplayarr'); ?>" >
          <option value="yes" <?php if ($sssdisplayarr == 'yes') echo 'selected="selected"'; ?>>yes</option>
          <option value="no" <?php if ($sssdisplayarr == 'no') echo ' selected="selected"'; ?>>no</option>
        </select>
      </label>
  </p>
<?php
  }
 
  function update($new_instance, $old_instance)
  {
    $instance = $old_instance;
    $instance['title'] = $new_instance['title'];
    $instance['pid'] = $new_instance['pid'];
    $instance['delay'] = $new_instance['delay'];
    $instance['ssheight'] = $new_instance['ssheight'];
    $instance['sssdisplaybul'] = $new_instance['sssdisplaybul'];
    $instance['sssdisplayarr'] = $new_instance['sssdisplayarr'];
    return $instance;
  }
 
  function widget($args, $instance) {
    extract($args, EXTR_SKIP);
    global $post;
 
    echo $before_widget;
    $title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
    $pid = empty($instance['pid']) ? ' ' : apply_filters('widget_pid', $instance['pid']);
    $delay = empty($instance['delay']) ? ' ' : apply_filters('widget_delay', $instance['delay']);
    $ssheight = empty($instance['ssheight']) ? ' ' : apply_filters('widget_ssheight', $instance['ssheight']);
    $sssdisplaybul = empty($instance['sssdisplaybul']) ? ' ' : apply_filters('widget_sssdisplaybul', $instance['sssdisplaybul']);
    $sssdisplayarr = empty($instance['sssdisplayarr']) ? ' ' : apply_filters('widget_sssdisplayarr', $instance['sssdisplayarr']);
    
    $ssswidgid = str_replace("-", "", $this->id);
     
    if (!empty($title))
      echo $before_title . $title . $after_title;;
 
    // WIDGET CODE GOES HERE   
    $photos = get_children( array('post_parent' => $pid, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID') );
    
    $results = array();
    
    if ($photos) {
      $ssswi = 0;
      foreach ($photos as $photo) {
        // get the correct image html for the selected size
        
        $photosrc =  wp_get_attachment_image_src($photo->ID, $size);
        $photoalt =  htmlspecialchars(get_post_meta($photo->ID, '_wp_attachment_image_alt', true));
        $phototitle = htmlspecialchars(get_the_title($photo->ID));
        $photolink =  htmlspecialchars(get_attachment_link($photo->ID, $size));
        $photocustlink =  htmlspecialchars(get_post_meta($photo->ID, '_ssscustomlink', true));
        $photocaption =  htmlspecialchars($photo->post_excerpt);
        $photodescr =  htmlspecialchars($photo->post_content);
        
        $ssscaption = '<span>'.$phototitle.'</span>';
        if ($photodescr <> '') { $ssscaption .= ' - '. $photodescr; }
        
        if ($ssswi == 0) {
          $actslide = '<img src="'. $photosrc[0] .'" alt="'. $photoalt .'" title="'. $phototitle .'" width="'. $photosrc[1] .'" height="'. $photosrc[2] .'" />';
          if ($photocustlink != '') {
            $slidedescr = '<a href="'. $photocustlink .'" title="'. $phototitle .'" >'. $ssscaption .'</a>';
          } else {
            $slidedescr = $ssscaption ;
          }
        }
        
        if ($ssswi > 0) {
          $restslides .= '<a href="'. $photosrc[0] .'" rel="'. $photosrc[1] .'|'. $photosrc[2] .'|'.$phototitle .'|'. $photodescr .'|'. $photocustlink.'" title="'. $phototitle .'">'.$phototitle .' - '. $photodescr .'</a>';
        }

        $ssswi++;
      }
    }
    echo '
    <div class="'. $ssswidgid .' ssslideshow ssswcustom">
      '. $actslide;
      if ($sssdisplayarr != 'no') {
      echo '
        <div class="sss-arrow-left sssarrow"></div>
        <div class="sss-arrow-right sssarrow"></div>
        ';
      }
      if ($sssdisplaybul != 'no') {
      echo '
        <div class="'. $ssswidgid .' slidedots"></div>
        ';
      }
      echo '
      <div class="'. $ssswidgid .' slidedescr">'. $slidedescr .'</div>
      
      <div class="'. $ssswidgid .' restslides">
      '. $restslides .'
      </div>
      <div class="sssdelay">'. $delay * 1000 .'</div>
      <div class="sssheight">'. $ssheight .'</div>
    </div>
    
    ';
    echo $after_widget;
  }
 
} // end of class


/**** ADD CUSTOM LINK START ****/


function sss_image_attachment_fields_to_edit($form_fields, $post) {

	$form_fields["ssscustomlink"] = array(
		"label" => __("Custom Link"),
		"input" => "text", // this is default if "input" is omitted
		"value" => get_post_meta($post->ID, "_ssscustomlink", true),
    "helps" => "Fill this only if you want the slideshow image caption to link to a page"
	);	
	return $form_fields;
}
// attach our function to the correct hook
add_filter("attachment_fields_to_edit", "sss_image_attachment_fields_to_edit", null, 2);

/**
 * @param array $post
 * @param array $attachment
 * @return array
 */
function sss_image_attachment_fields_to_save($post, $attachment) {
	if( isset($attachment['ssscustomlink']) ){
		update_post_meta($post['ID'], '_ssscustomlink', $attachment['ssscustomlink']);
	}
  
	return $post;
}
add_filter("attachment_fields_to_save", "sss_image_attachment_fields_to_save", null, 2);


/**** ADD CUSTOM LINK END ****/

add_action( 'widgets_init', create_function('', 'return register_widget("simpleSEOSlideshowWidget");') );
wp_enqueue_script('simpleslideshowjs', WP_PLUGIN_URL .'/simple-seo-slideshow/simpleslideshow.js', array('jquery'), '1.0.0', false);
wp_enqueue_style('simpleslideshowcss', WP_PLUGIN_URL .'/simple-seo-slideshow/simpleslideshow.css', array(), false, 'all');
?>